/* ------------------------------------------------------------------------ */
/* Bekijk.c 1.2.1                  (GPL) 1997,98,2000,2001  Belgie  Belgium */
/*							    Staf Wagemakers */
/* ------------------------------------------------------------------------ */
#define TAB 9
#define TYPE_WIDTH 59
#include <ncurses.h>
#include <malloc.h>
#include <string.h>
#include <signal.h>
#include <libio.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include "input.h"
#include "win.h"
#include "view.h"
#include "config.h"
#include "msg.h"
#ifdef _NED
#include "ned.h"
#endif
#ifdef _ENG
#include "eng.h"
#endif
WINDOW *win1,*win2,*w;          /* Midden scherm, Onderscherm + alg. venster*/
INPUT_STRING zoek_str;
char s[10]={'\0'};		/* String voor de te-zoeken-tekst	    */
char *ss=NULL;
chtype kleur[12];		/* Array voor het bewaren van de kleuren    */
char free_vb=0;
unsigned brol,zoek_offset=0;
unsigned long zoek_y;
int  zoek_mode;			/* Ondersheid tussen G & k ?????	    */
MENU m_ok,m_jn;
VIEW_PAR bv;
/* ------------------------------------------- 
 * Afsluiten van het prg
 * ------------------------------------------- */
static void terminate (int sig)
{
endwin();
freopen("/dev/tty","w",stderr);
fprintf(stderr,"\n %s %d\n",txt_term,sig);
exit (0);
}
/* ------------------------------------------- */
/* Procedure voor het sluiten van menu venster */
/* ------------------------------------------- */	
void m_close(MENU *m)
{
delwin(m->w);
touchwin(win1);
wrefresh(win1);
}
/* --------------------------------------------------- */
/* Procedure voor het openen van het bestandsmenu .... */
/* --------------------------------------------------- */
void open_bm (MENU *m)
{
m->w=open_win(7,m->l+2,1,1); 
m_open(m,win1);   
mvwaddch(m->w,2,0,ACS_LTEE);
whline(m->w,ACS_HLINE,m->l);
mvwaddch(m->w,2,m->l+1,ACS_RTEE);
mvwaddch(m->w,4,0,ACS_LTEE);
whline(m->w,ACS_HLINE,m->l);
mvwaddch(m->w,4,m->l+1,ACS_RTEE);
}
/* ----------------------------------------- */
/* Procedure voor het openen van het ga-menu */
/* ----------------------------------------- */
void open_gm (MENU *m)
{
m->w=open_win(7,m->l+2,1,(m->parent)->place[3]);
m_open(m,win1);   
}
/* ------------------------------------------- */
/* Procedure voor het openen van het zoek-menu */
/* ------------------------------------------- */
void open_zm (MENU *m)
{
m->w=open_win(5,m->l+2,1,(m->parent)->place[5]);
m_open(m,win1);   
}
/* ------------------------------------------- */
/* Procedure voor het openen van het optie-menu*/
/* ------------------------------------------- */
void open_om (MENU *m)
{
m->w=open_win(8,m->l+2,1,(m->parent)->place[7]);
m_open(m,win1);   
mvwaddch(m->w,3,0,ACS_LTEE);
whline(m->w,ACS_HLINE,m->l);
mvwaddch(m->w,3,m->l+1,ACS_RTEE);
mvwaddch(m->w,5,0,ACS_LTEE);
whline(m->w,ACS_HLINE,m->l);
mvwaddch(m->w,5,m->l+1,ACS_RTEE);
}
/* ------------------------------------------- */
/* Procedure voor het openen van het help-menu */
/* ------------------------------------------- */
void open_hlpm (MENU *m)
{
m->w=open_win(5,m->l+2,1,COLS-m->l-2);
m_open(m,win1);   
}
/* ----------------------------------------- */
/* Open van best. selektie menu              */
/*                                           */
/* Geeft terug: 0 -> ok 1 -> ESC             */
/* ----------------------------------------- */
int open_best()
{
int i;
char *vb;
chtype kl[3]={kleur[1],kleur[4],kleur[2]};
vb=bv.filename;
bv.filename=open_filewin(win2,txt_bo,kl,win1);
if (bv.filename) {
  if (view_load()) {
    free(bv.filename); 
    bv.filename=vb;
    }
    else {
     if(free_vb) free(vb);
     bv.y=0;bv.x=0;
     view_refresh();
     };
  free_vb=1;   
}
else {bv.filename=vb;return(1);}
return(0);
}
/* --------------------------------------------	*/
/* Openen van het zoek venster			*/
/*						*/
/* char     *s = pointer naar string		*/
/* char *titel = pointer naar venster-titel	*/
/* char *tekst = pointer naar info-tekst	*/
/*						*/
/* Geeft terug 0 -> geen onderscheid G & k	*/
/*             1 -> ondersheid G & k		*/
/*	       2 -> break			*/
/* --------------------------------------------	*/
int open_zoek_venster (char *titel,char *tekst)
{
MENU m;
int brol;
int toetsen[]={27,9,0};
int pl_ok[]={4,7,6,15,6,35};
int key_m[]={0,9,'\n',' ','\n','\n'};
w=open_cwin(8,60);
m.w=w;
m.amount=3;
m.l=0;
m.txt=txt_m_zoek;
m.place=pl_ok;
m.color1=kleur[2];
m.color2=kleur[4];
m.color3=kleur[7];
m.color4=kleur[6];
m.sel=m.used=0;
m.key=key_m;
m.hkey=hkey_zoek;
m.hplace=hplace_zoek;
zoek_str.w=w;
zoek_str.yp=2;
zoek_str.xp=22;
zoek_str.key=toetsen;
wbkgd(w,kleur[2]);
box(w,0,0);
echo();
leaveok(w,FALSE);
curs_set(1);
mvwaddstr(w,0,2,titel);
mvwaddstr(w,2,2,tekst);
mvwaddstr(w,4,6,txt_ondersheid_g);
wmove (w,2,22);
wbkgdset(w,kleur[11]);
for (brol=0;brol<=32;brol++) waddch(w,' ');
do {
  menu_print(&m);
  m.sel=0;
  wbkgdset(w,kleur[11]);
  if (brol!=1) brol=input(&zoek_str);
    else brol=2;
  curs_set(0);
  leaveok(w,TRUE);
  if (!brol) {
   if (m.txt[0]==txt_spacie)  return(0);
   return(1);
   };
  if (brol!=2) return(2);
  do { 
    brol=menu_key(&m);
    if ((brol==2)&&(m.sel==0)) break;
   } while(brol<3);
  if ((m.sel==0)&&(brol>2)) {
    if (m.txt[0]==txt_spacie) m.txt[0]=txt_X;
      else m.txt[0]=txt_spacie;
    brol=1;
    };
} while(brol<3);
if (m.sel==1) {
  if (m.txt[0]==txt_spacie) return(0);
  return(1);
  };
return (2);
}
/* --------------------------------------------	*/
/* Konverteert een string naar grootte letters	*/
/* -------------------------------------------- */
void str_toupper (char *c)
{
int i=0;
do {c[i]=toupper(c[i]);++i;} while (c[i]!=0);
}
/* --------------------------------------------	*/
/* Print de gevonden tekst in de juiste kleur	*/
/* -------------------------------------------- */
void print_zoek (char *c,char *cp,char *sp,char *rp,unsigned i)
{
  int brol;
  brol=cp-c;
  cp=rp+brol;
  strncpy(sp,cp,strlen(zoek_str.c));
  zoek_y=i;
  zoek_offset=cp-rp;
  view_setx(zoek_offset);
  if ((bv.sx+strlen(sp))>bv.cols) { 
     bv.x+=bv.sx+strlen(sp)-bv.cols;
     bv.sx-=bv.sx+strlen(sp)-bv.cols;
     }
  if (((bv.x+bv.cols)>strlen(c))&&(strlen(c)>bv.cols)) {
     bv.x=strlen(c)-bv.cols;
     bv.sx=zoek_offset-bv.x;
  } 
  view_sety(zoek_y);
  view_refresh();
  zoek_offset++;
  wmove (bv.win,bv.sy,bv.sx);
  wbkgdset(bv.win,kleur[1]);
  view_addstr(sp);
  wbkgdset(bv.win,kleur[10]);
  wmove (bv.win,bv.sy,bv.sx);
  wrefresh(bv.win);
  free(rp);
}
/* --------------------------------------------	*/
/* Funktie voor het zoeken van tekst ...	*/ 	
/*						*/
/* unsigned long start = bestand te-zoeken-van	*/
/* int mode  = 0 -> geen ondersheid G & k	*/
/*           = 1 -> ondersheid G & k		*/
/* --------------------------------------------	*/
void zoek(unsigned long start,int mode)
{
char *cp,*rp;
char *c;
char *sp;
int e=0;
unsigned i,l;
do {
l=0;
sp=NULL;
c=NULL;
if ((start==0)&&(view_getx()==1)) e=1;
if (zoek_y!=start) zoek_offset=0;
 if (view_par(NULL)->mode) {
    getyx(bv.win,bv.sy,bv.sx);
    zoek_offset=view_getx();
   }; 
for (i=start;i<bv.y_max;i++) {
  if(i!=start) zoek_offset=0;
  rp=view_getstr(i);
  c=xrealloc(c,strlen(rp)+1);
  sp=xrealloc(sp,strlen(zoek_str.c)+1);
  strcpy(c,rp);
  strcpy(sp,zoek_str.c);
  if (txt_m_zoek[0]==txt_spacie) {
    str_toupper(sp);
    str_toupper(c);
    };
  wrefresh(win2);
  cp=strstr(c+zoek_offset+l,sp);
  if (cp!=NULL) break;
  zoek_offset=0;
  free(rp);
  }
if (cp!=NULL) {
  print_zoek(c,cp,sp,rp,i);
  e=0; 
 }
  else {
    if(!e) { e=open_ynwin(6,55,&m_jn,txt_verder_zoeken,win1);
             if(e) {bv.x=bv.sx=start=0;wmove(bv.win,bv.sy,bv.sx);}
	   }
      else { e=0;
             open_okwin(6,40,&m_ok,txt_t_nt_gevonden,win1);
	   }  
		 
    }
free(c);
free(sp);
touchwin(win1);
wrefresh(win1);
} while (e);
}  
/* -------------------------------------------- */
/* Funktie voor het inlezen van te-zoeken-tekst */
/* char  mode :  0 -> huidige positie		*/
/*               1 -> van begin			*/
/* -------------------------------------------- */
void zoek_tekst (char mode)
{
zoek_mode=open_zoek_venster(txt_z_v_tekst,txt_geef_de_tekst);
delwin(w);
touchwin(win1);
wrefresh(win1);
if (zoek_mode<2) {
  if (mode) zoek(0,zoek_mode);
    else zoek(view_gety()-1,zoek_mode);
  }
  else zoek_mode=1;
ss=(char *) xrealloc(ss,strlen(zoek_str.c)+1);
strcpy(ss,zoek_str.c);
}
/* -------------------------------------------- */
/* Funktie om naar de lijnnr. te gaan ...       */
/* -------------------------------------------- */
ga_lijn ()
{
MENU m;
int brol;
unsigned long y;
char *txt[]={txt_ga_lijn,txt_geef_lijnnr};
INPUT_STRING s;
m.txt=txt_ok_anu;
m.hkey=hkey_ok_anu;
m.hplace=hplace_ok_anu;
m.color1=kleur[2];
m.color2=kleur[4];
m.color3=kleur[7];
m.color4=kleur[6];
brol=open_inputwin(7,60,&m,kleur[11],&s,txt,1,win1);
curs_set(0);
if (strlen(s.c)&&!brol) {
   sscanf(s.c,"%d",&y);
   if (y) --y;
     else bv.y=0;
   view_sety(y);
   view_refresh();
   }
if (s.c!=NULL) free(s.c);
}
/* -------------------------------------------- */
/* Bijvoegen van een type ...                   */
/* -------------------------------------------- */

add_type (int *n,char *name,char *val)
{
int i,max;
char ***ccc;
i=0;
while(bv.view_exec[i]!=NULL) ++i;
max=i+1;
bv.view_exec=xrealloc(bv.view_exec,sizeof(char **)*(max+1));
bv.view_exec[max]=NULL; 
i=*n;
for (i=max;i>*n;i--) bv.view_exec[i]=bv.view_exec[i-1];

bv.view_exec[*n]=xmalloc(sizeof(char *)*2); 
bv.view_exec[*n][0]=xmalloc(strlen(name)+1);
strcpy(bv.view_exec[*n][0],name);
bv.view_exec[*n][1]=xmalloc(strlen(val)+1);
strcpy(bv.view_exec[*n][1],val);
}

/* --------------------------------------------	*/
/* char     *s = pointer naar string		*/
/* char *titel = pointer naar venster-titel	*/
/* char *tekst = pointer naar info-tekst	*/
/* n	       = plaats				*/
/* mode	       = 0 -> bijvoegen			*/
/*		 1 -> aanpassen			*/
/* --------------------------------------------	*/
int open_type_venster (char *titel,char *txt_typename,char *txt_typeval,int n,int mode)
{
WINDOW *w;
MENU m;
INPUT_STRING ip_name,ip_val;
char ***ccc;
int brol;
int toetsen[]={27,9,0};
int pl_ok[]={7,11,7,31};
int key_m[]={0,9,'\n',' ','\n',27};
w=open_cwin(10,50);
ccc=bv.view_exec;
m.w=w;
m.amount=2;
m.l=0;
m.txt=txt_m_type;
m.place=pl_ok;
m.color1=kleur[2];
m.color2=kleur[4];
m.color3=kleur[7];
m.color4=kleur[6];
m.sel=m.used=0;
m.key=key_m;
m.hkey=hkey_type;
m.hplace=hplace_type;
ip_val.w=ip_name.w=w;
ip_name.yp=2;ip_val.yp=4;
ip_val.xp=ip_name.xp=17;
if (mode!=0) { 
  ip_name.c=(char *) xmalloc(strlen(ccc[n][0]));
  strcpy(ip_name.c,ccc[n][0]+1);
  ip_val.c=(char *) xmalloc(strlen(ccc[n][1])+1);
  strcpy(ip_val.c,ccc[n][1]);
  }
  else ip_name.c=ip_val.c=NULL;
ip_val.n=ip_name.n=29;
ip_val.m=ip_name.m=0;
ip_val.count=ip_name.count=0;
ip_val.mode=ip_name.mode=0;
ip_val.insert=ip_name.insert=1;
ip_val.ox=ip_name.ox=0;

ip_val.key=ip_name.key=toetsen;
wbkgd(w,kleur[2]);
box(w,0,0);
echo();
leaveok(w,FALSE);
curs_set(1);
mvwaddstr(w,0,2,titel);
mvwaddstr(w,2,2,txt_typename);
mvwaddstr(w,4,2,txt_typeval);
wmove (w,2,16);
waddch(w,'.');
wbkgdset(w,kleur[11]);
for (brol=0;brol<=ip_name.n;brol++) waddch(w,' ');
wmove (w,4,17);
for (brol=0;brol<=ip_val.n;brol++) waddch(w,' ');
input_show_string(&ip_val);
do {
  menu_print(&m);
  m.sel=0;
  wbkgdset(w,kleur[11]);
  if (brol!=1) brol=input(&ip_name);
    else brol=2;
  leaveok(w,TRUE);
  curs_set(0);
  if (brol==1) break;
  brol=input(&ip_val);
  leaveok(w,TRUE);
  curs_set(0);
  if (brol==1) break;
  do { 
      brol=menu_key(&m);
      if ((brol==2)&&(m.sel==0)) break;
   } while(brol<3);
} while(brol<3);
if ((m.sel==0)&&(brol==3)) {
   int t=n;
   char *c;
   if (mode!=0) { 
      t=n;
   ccc[t][0]=xrealloc(ccc[t][0],strlen(ip_name.c)+2);
   strcpy(ccc[t][0],".");
   strcat(ccc[t][0],ip_name.c);
   ccc[t][1]=xrealloc(ccc[t][1],strlen(ip_val.c)+1);
   strcpy(ccc[t][1],ip_val.c);
   }
   else { 
	     c=xmalloc(strlen(ip_name.c)+2);
	     strcpy(c,".");
	     strcat(c,ip_name.c);
	     add_type(&t,c,ip_val.c);
	     free(c);
           }
   }
free(ip_name.c);
free(ip_val.c); 
delwin(w); 
}
/* -------------------------------------------- */
/* wissen van een type ...                      */
/* -------------------------------------------- */

delete_type(int *n)
{
int i;
free(bv.view_exec[*n][1]);
free(bv.view_exec[*n][0]);
free(bv.view_exec[*n]);
i=*n+1;
while(bv.view_exec[i]!=NULL) { 
  bv.view_exec[i-1]=bv.view_exec[i];
  i++;
  }
bv.view_exec[i-1]=NULL;
bv.view_exec=xrealloc(bv.view_exec,(i+1)*sizeof(char **)); 
}
/* -------------------------------------------- */
/* bv.view_exec omzetten naar een string...     */
/* -------------------------------------------- */
char **view_exec_2_str(int *a)
{
char ***ccc,**cc;
ccc=bv.view_exec;
cc=(char **) xmalloc(sizeof(char*));
*a=0;
while(*ccc) {
   int l1,l0;
   int n;
   l0=strlen(ccc[0][0]);
   l1=strlen(ccc[0][1]);
   if (l0>((TYPE_WIDTH/2)-1)) l0=(TYPE_WIDTH/2)-1; 
   if (l1>((TYPE_WIDTH/2)-1)) l1=(TYPE_WIDTH/2)-1; 
   cc[*a]=(char *)xmalloc(TYPE_WIDTH+1);
   strncpy(cc[*a],ccc[0][0],l0);
   cc[*a][l0]='\0';
   for(n=0;n<(TYPE_WIDTH-l0-l1);n++) strcat(cc[*a]," ");
   strncat(cc[*a],ccc[0][1],l1);
   cc[*a][TYPE_WIDTH]='\0'; 
   ++ccc;
   ++*a;
   cc=(char **)xrealloc(cc,sizeof(char*)*(*a+1));
}
return(cc);
}
/* -------------------------------------------- */
/* type geheugen terug vrijgeven                */
/* -------------------------------------------- */

void free_type(char **cc,int a)
{
int i;
for (i=0;i<=a-1;i++) free(cc[i]);
free(cc);
cc=NULL;
}
/* -------------------------------------------- */
/* Funktie voor types...       */
/* -------------------------------------------- */
set_types ()
{
MENU m,mm;
WINDOW *w;
int key_m[]={KEY_UP,KEY_DOWN,'\n',KEY_PPAGE,KEY_NPAGE,27,9};
int key_mm[]={0,9,'\n',' ',27,'\n'};
int pl_m[]={2,5,3,5,4,5,5,5,6,5,7,5,8,5,9,5,10,5,11,5,12,5,13,5,14,5};
int pl_mm[]={15,1,15,1,15,1,15,1,15,1,2,5};
int s,i,brol=0;
char ***ccc=NULL;
char **cc=NULL;
char *c=NULL;
unsigned u=0;
i=(TYPE_WIDTH+11-strlen(txt_typem[0])-strlen(txt_typem[1])-strlen(txt_typem[2])-strlen(txt_typem[3])-strlen(txt_typem[4]))/6;
pl_mm[1]=1+i;
pl_mm[3]=pl_mm[1]+i+strlen(txt_typem[0]);
pl_mm[5]=pl_mm[3]+i+strlen(txt_typem[1]);
pl_mm[7]=pl_mm[5]+i+strlen(txt_typem[2]);
pl_mm[9]=pl_mm[7]+i+strlen(txt_typem[3]);
cc=view_exec_2_str(&brol);
m.color1=kleur[1];
m.color2=kleur[0];
m.color3=kleur[3];
m.place=pl_m;
m.key=key_m;
m.l=TYPE_WIDTH;
m.hkey=m.hplace=NULL;
w=open_cwin(18,TYPE_WIDTH+10);
m.w=w;
m.used=m.sel=0;
mm.w=w;
mm.l=0;
mm.place=pl_mm;
mm.sel=mm.used=0;
mm.txt=txt_typem;
mm.color1=kleur[1];
mm.color2=kleur[4];
mm.color3=kleur[5];
mm.color4=kleur[6];
mm.hkey=hkey_typem;
mm.hplace=hplace_typem;
mm.amount=6;
mm.key=key_mm;
leaveok(w,TRUE);
curs_set(0);
keypad(w,TRUE);
nodelay(w,FALSE);
wbkgdset(w,kleur[1]);
werase(w);
box(w,0,0);
win_box(w,12,TYPE_WIDTH+3,1,3);
do { 
   if (brol<11) {
     m.amount=brol;
     wmove(w,brol+2,5);
     wbkgdset(w,kleur[1]);
     for(i=0;i<TYPE_WIDTH;i++) waddch(w,' ');
     wrefresh(w);
     }
     else m.amount=11;
   m.txt=cc;

menu_print(&mm);
wrefresh(w);
if(u>brol-1) u=brol-1;
m.sel=u;
if(brol) i=scroll_menu(&m,brol,NULL,&u);
  else i=2;
mm.sel=0;
switch (i) {
   case 0 :  open_type_venster(txt_c_type,txt_typename,txt_typeval,m.sel,1);
             touchwin(w);
	     wrefresh(w);
             break;
   case 1 :  mm.sel=4;
             break;
   case 2 :  do {
             s=menu_key(&mm);
             if ((s==2)&&(mm.sel==5)) break; 
	     } while(s<3);
	     if (s==5) mm.sel=4;
	     break; 
   default:  break;
   }
if(i) {
switch(mm.sel) {
   case 0 :  open_type_venster(txt_n_type,txt_typename,txt_typeval,m.sel,0);
	     break;
   case 1 :  if (m.amount) open_type_venster(txt_n_type,txt_typename,txt_typeval,m.sel+1,0);
                else open_type_venster(txt_n_type,txt_typename,txt_typeval,m.sel,0);
	     break;
   case 2 :  if (brol) open_type_venster(txt_c_type,txt_typename,txt_typeval,m.sel,1);
             break;
   case 3 :  if (brol) delete_type(&m.sel);
             break;
   case 4 :  break;
   }
   }
  touchwin(w);
  wrefresh(w);
  free_type(cc,brol);
  cc=view_exec_2_str(&brol);
  } while ((mm.sel<4)||(mm.sel==5)); 
delwin(w);
free_type(cc,brol);
}

void cp2stdout(FILE *fp)
{
char c;
while(1) {
	 if ((c=getc(fp))==EOF) break;
	 fputc(c,stdout);
	 }
fclose(fp);
fclose(stdout);
}
FILE * get_config_file (const char *opentype)
{
FILE *fp;
char *c,*file;
if ((c=getenv("HOME"))==NULL) return(NULL); 
  else {
    file=(char *) malloc (strlen(c)+strlen("/.lookat")+1);
    strcpy(file,c);
    strcat(file,"/.lookat");
    fp=fopen(file,opentype); 
  }
if (fp==NULL) {
   free(file);
   file=(char *) malloc (strlen("/etc/lookat.conf")+1);
   strcpy(file,"/etc/lookat.conf");
   fp=fopen(file,opentype); 
   }
free(file);
return (fp);
}
int exit_lookat(void) {
if (txt_om2[1]==' ') return 1;
return(open_ynwin(6,43,&m_jn,txt_stop,win1));
}

/* ---------------------------------------------------- */ 
/* Hoofdprg ...						*/
/* ---------------------------------------------------- */ 
main(int arg1,char *arg2[])
{
VIEW_PAR *vp;
struct view_exec *exec;
int i,ii,c;
WINDOW *hm_win,*sub_win;
char **cp,*sp;
int  pl_hm[]={0,1,0,9,0,12,0,15,0,17};
int  pl_bm[]={1,1,3,1,5,1};
int  pl_gm[]={1,1,2,1,3,1,4,1,5,1,};
int  pl_zm[]={1,1,2,1,3,1,};
int  pl_om[]={1,1,2,1,4,1,6,1};
int  pl_hlpm[]={1,1,2,1,3,1,};
int key_sub[]={KEY_UP,KEY_DOWN,'\n',KEY_LEFT,KEY_RIGHT,27};
int key_hm[]={KEY_LEFT,KEY_RIGHT,'\n',KEY_UP,KEY_DOWN,27};
MENU hm,bm,gm,zm,om,hlpm;
MENU *sub_hm[]={&bm,&gm,&zm,&om,&hlpm};
MENU *sub_NULL[]={NULL,NULL,NULL,NULL,NULL,NULL};
FILE *fp;
char ***ccc;
set_memerr(txt_f_geh);
s[0]=0;
{
char *c;
char **type;
int tt=0;
bv.view_exec=xmalloc(sizeof(char ***)); 
if ((fp=get_config_file("r"))==NULL) bv.mode=0;
  else {
    c=get_config(fp,"cursor");
    if (c!=NULL) {
       if (!strcmp(c,"on")) {txt_om1[1]='X';bv.mode=1;}
       else bv.mode=0;
       }
    c=get_config(fp,"give_notice");

    if (c!=NULL) {
       if (!strcmp(c,"off")) txt_om2[1]=' ';
       }

    while ((type=get_next_config(fp))!=NULL) {
          if(type[0][0]=='.') {
	    bv.view_exec=xrealloc(bv.view_exec,sizeof(char ***)*(tt+1));
	    bv.view_exec[tt]=xmalloc(sizeof(char **));
	    bv.view_exec[tt]=type;
	    ++tt;
          }
    } 
    bv.view_exec=xrealloc(bv.view_exec,sizeof(char ***)*(tt+1));
    bv.view_exec[tt]=xmalloc(sizeof(char **));
    bv.view_exec[tt]=NULL; 
    fclose (fp);
  }
}
bv.file=NULL;
bv.filename=NULL;
bv.cmd=1;
bv.load=0;
bv.txt_f_open2=txt_f_open2;
bv.txt_f_open1=txt_f_open1;
bv.txt_f_load=txt_f_laden;
bv.txt_f_fseek=txt_f_fseek;
if (!(initscr())) {
   fprintf(stderr,txt_f_initscr);exit(1);
   }
bv.lines=LINES-2;
bv.cols=COLS;
bv.sx=bv.sy=0;
view_par(&bv);
if (!isatty(STDIN_FILENO)) {
   if (!isatty(STDOUT_FILENO)) {
      cp2stdout(stdin);
      fclose(stdin);
      fclose(stdout);
      wexit(0);
      }
   bv.cmd=2;
   bv.filename=(char *)malloc(strlen("STDIN"));
   strcpy(bv.filename,"STDIN");
   view_load();
   freopen("/dev/tty","r",stdin);
   arg1=2;
   }
else {
if (arg1>=2) { 
if (!strcmp(arg2[1],"--help")) {
   if(COLS) endwin();
   print_strs(stderr,txt_help);
   exit(0);
   };
if (chdir(arg2[1])==-1) {
      bv.filename=(char *)xmalloc(strlen(arg2[1])+1);
      strcpy(bv.filename,arg2[1]);
      if (isatty(STDOUT_FILENO)) view_load();
        else {
	 FILE *fp;
	 if ((fp=fopen(bv.filename,"r"))==NULL) {
	    fprintf(stderr,"%s %s %s",txt_f_open1,bv.filename,txt_f_open2); 
	    fclose(stdout);
	    wexit(1);
	 }
         cp2stdout(fp);
	 wexit(0);
	}
      }
      else arg1=1;
    }
}


if (!isatty(STDOUT_FILENO)) wexit(1);
bv.cmd=0;
cp=bv.file;bv.x=0;s[0]=0;
win_set_errmesg(txt_f_venster);
win1=open_win(LINES-2,COLS,1,0);
win2=open_win(1,COLS,LINES-1,0);
hm_win=open_win(1,COLS,0,0);
hm.w=hm_win;
keypad(hm.w,TRUE);
start_color();
if(has_colors()) {
  init_pair(1,COLOR_BLACK,COLOR_CYAN);
  init_pair(2,COLOR_BLACK,COLOR_WHITE);
  init_pair(3,COLOR_WHITE,COLOR_BLUE);
  init_pair(4,COLOR_WHITE,COLOR_BLACK);
  init_pair(5,COLOR_YELLOW,COLOR_CYAN);
  init_pair(6,COLOR_YELLOW,COLOR_BLACK);
  init_pair(7,COLOR_YELLOW,COLOR_WHITE);
  init_pair(8,COLOR_YELLOW,COLOR_BLUE);
  init_pair(9,COLOR_RED,COLOR_BLUE);
  kleur[1]=COLOR_PAIR(1);
  kleur[2]=COLOR_PAIR(2);
  kleur[3]=COLOR_PAIR(3);
  kleur[4]=COLOR_PAIR(4)|A_BOLD;
  kleur[5]=COLOR_PAIR(5)|A_BOLD;
  kleur[6]=COLOR_PAIR(6)|A_BOLD;
  kleur[7]=COLOR_PAIR(7)|A_BOLD;
  kleur[8]=COLOR_PAIR(8)|A_BOLD;
  kleur[9]=COLOR_PAIR(9)|A_BOLD;
  kleur[10]=A_BOLD|kleur[3];
  kleur[11]=kleur[1];
  wbkgd(win1,kleur[10]);
  }
 else{    
  	 init_pair(1,COLOR_WHITE,COLOR_BLACK);
	 kleur[1]=COLOR_PAIR(1)|A_REVERSE;
         kleur[2]=COLOR_PAIR(1)|A_REVERSE;
	 kleur[3]=COLOR_PAIR(1);                    /* achtergrond win1 */
	 kleur[4]=COLOR_PAIR(1);
	 kleur[5]=kleur[1]|A_BOLD;
	 kleur[6]=kleur[4]|A_BOLD;
	 kleur[7]=kleur[2];
	 kleur[8]=kleur[9]=COLOR_PAIR(1)|A_BOLD;
	 kleur[10]=kleur[3];
	 kleur[11]=kleur[3];
	 wbkgd(win1,kleur[10]);
         };  
wbkgd(win2,kleur[1]);
wbkgd(hm_win,kleur[1]);
signal(SIGINT,SIG_IGN);
signal(SIGTERM,terminate);
freopen("/dev/null","w",stderr);

/* ------------------------------------------------------------------------- */
/* START MENU INIT							     */
/* ------------------------------------------------------------------------- */
m_jn.txt=txt_jn;
m_jn.color1=kleur[1];
m_jn.color2=kleur[4];
m_jn.color3=kleur[5];
m_jn.color4=kleur[6];
m_jn.hkey=hkey_jn;
m_jn.hplace=hplace_jn;
m_ok.txt=txt_ok;
m_ok.color1=kleur[2];
m_ok.color2=kleur[4];
m_ok.color3=kleur[5];
m_ok.color4=kleur[6];
m_ok.hkey=hkey_ok;
m_ok.hplace=hplace_ok;
hm.sel=0;
hm.amount=5;
hm.place=pl_hm;
hm.txt=txt_hm;
hm.key=key_hm;
hm.hkey=NULL;
hm.next=sub_hm;
hm.parent=NULL;
hm.call_open=NULL;
hm.call_close=NULL;
hm.color1=bm.color1=gm.color1=zm.color1=om.color1=hlpm.color1=kleur[1];
hm.color2=bm.color2=gm.color2=zm.color2=om.color2=hlpm.color2=kleur[4];
hm.color3=bm.color3=gm.color3=zm.color3=om.color3=hlpm.color3=kleur[5]; 
hm.color4=bm.color4=gm.color4=zm.color4=om.color4=hlpm.color4=kleur[6];
bm.sel=gm.sel=zm.sel=om.sel=hlpm.sel=0;
bm.place=pl_bm;
gm.place=pl_gm;
zm.place=pl_zm;
om.place=pl_om;
hlpm.place=pl_hlpm;
bm.txt=txt_bm;
gm.txt=txt_gm;
zm.txt=txt_zm;
om.txt=txt_om;
hlpm.txt=txt_hlpm;
bm.next=gm.next=zm.next=om.next=hlpm.next=sub_NULL;
bm.parent=gm.parent=zm.parent=om.parent=hlpm.parent=&hm;
bm.key=gm.key=zm.key=om.key=hlpm.key=key_sub;
bm.call_open=open_bm;
gm.call_open=open_gm;
zm.call_open=open_zm;
om.call_open=open_om;
hlpm.call_open=open_hlpm;
bm.call_close=gm.call_close=zm.call_close=om.call_close=hlpm.call_close=m_close;
bm.w=gm.w=zm.w=om.w=hlpm.w=sub_win;
bm.amount=3;
hlpm.amount=3;
zm.amount=3;
om.amount=4;
gm.amount=5;
hm.l=bm.l=gm.l=zm.l=om.l=hlpm.l=0;
bm.hkey=hkey_bm;
gm.hkey=hkey_gm;
zm.hkey=hkey_zm;
om.hkey=hkey_om;
hlpm.hkey=hkey_hlp;
hm.hplace=hplace_hm;
bm.hplace=hplace_bm;
gm.hplace=hplace_gm;
om.hplace=hplace_om;
zm.hplace=hplace_zm;
hlpm.hplace=hplace_hlpm;

pl_hm[3]=strlen(txt_hm[0])+2;
pl_hm[5]=strlen(txt_hm[0])+strlen(txt_hm[1])+3;
pl_hm[7]=pl_hm[5]+strlen(txt_hm[2])+1;
pl_hm[9]=COLS-strlen(txt_hm[3])-2;
for (i=0;i<bm.amount;i++) 
  if (strlen(bm.txt[i])>bm.l) bm.l=strlen(bm.txt[i]);
for (i=0;i<gm.amount;i++) 
  if (strlen(gm.txt[i])>gm.l) gm.l=strlen(gm.txt[i]);
for (i=0;i<zm.amount;i++) 
  if (strlen(zm.txt[i])>zm.l) zm.l=strlen(zm.txt[i]);
for (i=0;i<om.amount;i++) 
  if (strlen(om.txt[i])>om.l) om.l=strlen(om.txt[i]);
for (i=0;i<hlpm.amount;i++) 
  if (strlen(hlpm.txt[i])>hlpm.l) hlpm.l=strlen(hlpm.txt[i]);
/* ------------------------------------------------------------------------- */
/* EINDE MENU INIT						             */
/* ------------------------------------------------------------------------- */

bv.m_ok=&m_ok;
bv.color=kleur;
bv.win=win1;
menu_print(&hm);
meta(win1,TRUE);
noecho();
cbreak();
leaveok(win1,TRUE);
curs_set(0);
keypad(win1,TRUE);
nodelay(win1,FALSE); 
nodelay(hm_win,FALSE);
leaveok(stdscr,TRUE);
leaveok(hm_win,TRUE);
curs_set(0);
keypad(stdscr,TRUE);
nodelay(stdscr,TRUE); 
keypad(hm_win,TRUE);
wrefresh(win1);
wrefresh(win2);

zoek_str.c=NULL;
zoek_str.n=32;
zoek_str.m=0;
zoek_str.count=0;
zoek_str.mode=0;
zoek_str.insert=1;

if (arg1<2) { 
  do {
    if (open_best()) {
      delwin(win1);
      delwin(win2);
      refresh();
      wexit(0);
      };
    } while (bv.file==NULL);
};
bv.y=0;view_refresh();
touchwin(win1);
touchwin(win2);
wrefresh(win1);
wrefresh(win2);

do {
do {
   if (bv.mode) { 
                leaveok(win1,FALSE);
		curs_set(1);
		}
      else { 
             leaveok(win1,TRUE);
	     curs_set(0);
           }
   werase(win2);
   mvwprintw(win2,0,0,"%s %4d / %4d  %s %4d %s %ld",
	txt_lijn,view_gety(),bv.y_max,txt_kol,view_getx(),txt_Grootte,bv.size);
   mvwprintw(win2,0,COLS-strlen(bv.filename)-3,"%s",bv.filename);
   touchwin(win1);
   touchwin(win2);
   wrefresh(win2);
   wrefresh(win1);
   c=wgetch(win1);
   if ((c==KEY_F(9))||(c==27)) {
      int m_sel=0;
      if (c==27) {
	nodelay(win1,TRUE);
        c=wgetch(win1);
	if (c==ERR) c=27;
	  else c=tolower(c);
	nodelay(win1,FALSE);
	if (c==sel_bm) m_sel=1;
	 else
	  if (c==sel_gm) m_sel=2;
	   else
	    if (c==sel_zm) m_sel=3;
             else
	       if (c==sel_om) m_sel=4;
                 else       
	          if (c==sel_hm) m_sel=5;
	       else m_sel=6;
      };
      if (m_sel<6) {
        c=0;
        werase(win2);
        mvwaddstr(win2,0,0,txt_maak_sel);
        wrefresh(win2);
        for (i=0;i<4;i++) sub_hm[i]->used=0;
        menu_pull(&hm,m_sel);
        for (i=0;i<hm.amount;i++) if (sub_hm[i]->used) break;
        menu_print(&hm);
        werase(win2);
        wrefresh(win2);
	if (hm.used==2) c=0;
	  else {
            switch (hm.sel) {
              case 0: switch (sub_hm[i]->sel) {
		        case 0:  c='o';
		                 break;
		         case 1:  c='r';
                                 break;
		         case 2:  c='q';
                                 break;
		         default: break;
		         }
		      break; 
              case 1: switch (sub_hm[i]->sel) {
		      case 0: c='t';
	                      break;
	              case 1: c='e';
                              break;
		      case 2: ga_lijn();
	                      break;
	              case 3: c=KEY_END;
	                      break;
	              case 4: c=KEY_HOME;
                              break;
	              default: break;
	              }
	              break;
             case 2: switch (sub_hm[i]->sel) {
		      case 0: c='z';
		              break;
	              case 1: zoek_tekst(1);
		              c=0;
			      break;
                      case 2: c=KEY_F(3);
		              break;
	              }
		      break;
	     case 3: switch (sub_hm[i]->sel) {
	              case 0:  if (bv.mode) {
			         bv.mode=0;
				 txt_om1[1]=txt_spacie[0];
		                 }
		                else {
					bv.mode=1;
					txt_om1[1]=txt_X[0];
					bv.y-=bv.lines;
					view_refresh();
				}
		               break;
		      case 1:  if (txt_om2[1]==' ') txt_om2[1]='X';
			       else txt_om2[1]=' ';
			       break;
		      case 2:  set_types();
		               break;
	              case 3:  if ((fp=get_config_file("w"))==NULL) {
		               #ifdef _NED
				open_okwin(7,40,&m_ok,txt_f_writecfg,win1);touchwin(win1);wrefresh(win1);
			       #endif
			       #ifdef _ENG
      				open_okwin(6,40,&m_ok,txt_f_writecfg,win1);touchwin(win1);wrefresh(win1);
			       #endif

				break;
		                  }
		               if (bv.mode) save_config(fp,"cursor","on");
		                  else save_config(fp,"cursor","off");
			       if (txt_om2[1]=='X') save_config(fp,"give_notice","on");
			          else save_config(fp,"give_notice","off");
				  ccc=bv.view_exec;
				  while(*ccc) {
				     sp=xmalloc(strlen(ccc[0][1])+3);
				     strcpy(sp,"\"");
				     strcat(sp,ccc[0][1]);
				     strcat(sp,"\"");
				     save_config(fp,ccc[0][0],sp);
				     ++ccc;
				     }
			       fclose(fp);
                               break;
	              };
		      break;
    	     case 4:   
                      switch (sub_hm[i]->sel) {
	                case 0: c='?';
		                break;
		        case 1: m_ok.color1=kleur[1];
			        open_okwin(22,60,&m_ok,txt_t,win1);
			        m_ok.color1=kleur[2];
			        break;
 		        case 2: open_animwin(12,60,&m_ok,txt_over,txt_bedank,win1,0);
		                break;
	                default:break;
		       }
		       break;
	      default: c=0;
                       break;
         }
    }
    }
    } 
    switch (c) {
    case '<'      :
    case 't'      :
    case 'T'      :  bv.y=0;bv.x=0;view_refresh();
                     break;
    case 'b'	  :
    case 'B'      :
    case '>'      :
    case 'E'      :
    case 'e'      :  bv.y=bv.y_max;bv.x=0;view_refresh();break;
    case '\n'	  :
    case 14       :
    case 'J'      :
    case 'j'      :
    case KEY_DOWN :  view_down();
                     break;    
    case 16       :
    case 'K'      :
    case 'k'      :
    case KEY_UP   :  view_up();
		     break;
    case ' '      :
    case 'd'      :
    case 'D'      :
    case KEY_NPAGE: view_refresh();
		    break;
    case 'u'      :
    case 'U'      :
    case KEY_PPAGE: view_previous(); 
		    break;  
    case 6        :
    case 'L'      :
    case 'l'      :
    case KEY_RIGHT: view_right();
                    break;
    case 2        :
    case KEY_LEFT : view_left(); 
                    break;
    case 'g'      :        
    case 'G'      :  ga_lijn();
		     break;
    case KEY_F(7) :
    case '/'      :
    case 'z'      :
    case 'Z'      :
    case 's'      :
    case 'S'      :
    case 'F'      :
    case 'f'      :  zoek_tekst(0);
		     break;
    case '\\'     :
    case 'v'      :
    case 'V'      :
    case 'c'      :
    case 'C'      :
    case KEY_F(3) :  if (zoek_str.c) zoek((view_gety()-1),1);
                       else zoek_tekst(0);
		     break;	
    case KEY_HOME :  bv.sx=bv.x=0;
    		     bv.y-=(LINES-2);
                     view_refresh();
		     break;
    case KEY_END  :  bv.y-=(LINES-2);
       		     if (!bv.mode) bv.x=view_strlen(bv.file[bv.y]);
	                else bv.x=view_strlen(bv.file[bv.y+bv.sy]);
		     if (bv.x<COLS) bv.x=0;
		     else bv.x-=COLS;
		     bv.sx=view_strlen(bv.file[bv.y+bv.sy])-bv.x-1;
	             view_refresh();
		     break;
    case 'o'      :
    case 'O'      :        
		     open_best();
		     cp=bv.file;bv.x=0;s[0]=0;
		     break;
    case 'R'      : 
    case 'r'      :  wrefresh(curscr);
	             break;
    case 'h'      :
    case 'H'      :
    case '?'      :
    case KEY_F(1) : { char *vb;
                      vb=bv.filename;
		      bv.filename=xmalloc(strlen(txt_hlppath)+1);
		      strcpy(bv.filename,txt_hlppath);
		      if (view_load()) {
		        free(bv.filename);
			bv.filename=vb;
			}
			else {
			  view_refresh();
			  if (free_vb) free(vb);
			  }
	             };  
        	     break;
    }
   } while ((c!='Q')&&(c!='q')&&(c!=27)&&(c!=KEY_F(10)));
} while (!exit_lookat());
touchwin(win1);
touchwin(win2);
wrefresh(win1);
wrefresh(win2);
delwin(win1);
delwin(win2);
endwin();
}
