/* ------------------------------------------------------------------------ */
/* (lookat / bekijk ) config.c             (GPL) 2000,2001  Belgie  Belgium */
/*                                                          Staf Wagemakers */
/* ------------------------------------------------------------------------ */
#include "config.h"
#include <stdlib.h>
#include <string.h>
#define BUFFER_LEN 200

/* ------------------------------------------- */
/* test op rem regel                           */
/* ------------------------------------------- */
int is_rem (char *c)
{
if(*c=='\n') return(1);
do {
    if ((!isspace(*c)&&(*c!='#'))) return(0);
    if (*c=='#') return(1);
    ++c;
} while (*c!='\0');
return(0);
}
/* ------------------------------------------- */
/* verwijdert alles achter spacie, tabs, etc   */
/* ------------------------------------------- */
void cut_space (char *c)
{	    
do {
   if (isspace(*c)) *c='\0';
   ++c;
} while (*c);
}
/* ------------------------------------------- */
/* ga naar het volgende item                   */
/* ------------------------------------------- */
char * mv_2_next (char *c)
{
do if (isspace(*c)) ++c; else break; while (*c);
return c;
}
/* ------------------------------------------- */
/* ga naar volgende quote                      */
/* ------------------------------------------- */
char * mv_2_quote (char *c)
{
char *cp;
cp=c;
do if (*c=='"') return(c); else ++c; while (*c);
return(cp);
}
/* ------------------------------------------- */
/* ga naar het  einde van de naam              */
/* ------------------------------------------- */
char * mv_2_par_end (char *c)
{
do if ((!isspace(*c))||(*c=='=')) c++; else break; while (*c);
return c;
}
char ** get_next_config(FILE *fp)
{
char **var,*r=NULL,*c,*cp,s[BUFFER_LEN];
if (s==NULL) return(NULL);
do {
   if(fgets(s,BUFFER_LEN,fp)==NULL) return (NULL);
   }
while (is_rem(s));
      cp=mv_2_next(s);
      c=mv_2_par_end(cp);
      if((var=(char **) malloc(sizeof(char *)+sizeof(char *)))==NULL) return(NULL);
      if((var[0]=(char *) malloc(c-cp+1))==NULL) { free(var); return(NULL);}
      strncpy(var[0],cp,(c-cp));
      var[0][c-cp]=0;
      c=mv_2_next(c);
      if (*c!='=') {
         var[1]=(char *) malloc(sizeof(char));
         if(var[1]==NULL); return (NULL);
	 var[1]='\0';
	 }
      else {
         ++c;
         cp=c;
         c=mv_2_quote(c);
	 if (c!=cp) {
            cp=mv_2_quote(c+1);
	    if((var[1]=(char *) malloc(cp-c+1))==NULL) {free(var); free(var[0]);return(NULL);}
            strncpy(var[1],c+1,cp-c-1); 
	    var[1][cp-c-1]=0;
	    }
	    else {
	         c=mv_2_next(c);
	         cut_space(c);
		 if((var[1]=(char *) malloc(strlen(c)+1))==NULL) {free(var);free(var[0]);return(NULL);}
		 strcpy(var[1],c);
		 }
      }
      return(var);
}

/* ------------------------------------------- */
/* leest een variable uit een config bestand   */
/*                                             */
/* fp   = stream                               */
/* var  = variable                             */
/* return = value                              */
/*          = NULL bij een fout                */
/* ------------------------------------------- */
char * get_config(FILE *fp,char *name)
{
char *r=NULL,*c,s[BUFFER_LEN];
char **var;
fseek(fp,0,SEEK_SET);
c=NULL;
while ((var=get_next_config(fp))) {
   if (!strcmp(name,var[0])) {
      if(c) free(c); 
      if((c=(char *) malloc(strlen(var[1]+1)))==NULL) return(NULL);
      strcpy(c,var[1]);
      }
free(var[0]);
free(var[1]);
free(var); 
} 
fseek(fp,0,SEEK_SET);
return (c);
}
/* ------------------------------------------- */
/* bewaard een variable in een config bestand  */
/*                                             */
/* fp   = stream                               */
/* var  = variable                             */
/* value= value                                */
/* return = value                              */
/*          = NULL bij een fout                */
/* ------------------------------------------- */
char * save_config(FILE *fp,char *var,char *value)
{
char *c=(char *)malloc(strlen(var)+strlen(value)+strlen(" = ")+strlen("\n")+1);
if (c==NULL) return(NULL);
strcpy(c,var);
strcat(c," = ");
strcat(c,value);
strcat(c,"\n");
fputs(c,fp);
return(value);
}
