.\" lookat.1
.\"
.TH LOOKAT 1 "MAY 25, 2001"
.AT 3
.SH NAME
\fBlookat\fP \- is a program to view Un*x text files and manual pages.

.SH SYNOPSIS
.B lookat
[
.B \-\-help
] <
.B filename
> <
.B dir_name
>

.SH DESCRIPTION
.PP
.TP
There are four way's to start \fBlookat\fP.

1. By just typing 'lookat', after the program is started you can select 
the file you want to view.
.br

.br
If there is already data on stdin, lookat will read the form stdin, and
display the contents of stdin
.br

example : ls | lookat

.br	 
2. type 'lookat <dir_name>', change the current directory to <dir_name>.
When the program is started you can select the file you want to view.
.br

3. by typing 'lookat <filename>', the file with <filename> will 
automatically be loaded.
.br

4. in combination with \fBman\fP.
       
examples : man -Plookat ls
           export PAGER=lookat;man ls
.br

If you like "lookat" as your manual page viewer you can put the next 
lines in your /etc/profile
.br	 

  alias man="man -Plookat"
.br

.TP
Keys:

  <-, C-b         : move left   / back
  ->, C-f         : move right  / forward
  arrow up, C-p   : move up     / previous line
  arrow down, C-n : move down   / next line
  PgUp, u         : move a screen up
  PgDwn, d        : move a screen down
  HOME            : go to the begin of a line 
  END             : go to the end of a line
  o               : open a new file
  t, <            : go to the first line 
  e, b, >         : go to the last line
  g               : go to a line number
  /,z,s,f         : search a string
  F3, c, v        : continue search 
  F9              : menu
  ALT+f           : file menu
  ALT+g           : go menu
  ALT+s           : search menu
  ALT+h           : help menu
  F10,ESC,q       : quit program
  F1,h,?          : view help file
  r               : rebuild screen
.br

When you press F9 you get access to the pull-down menu's, most of the 
functions are also available through the keyboard (see above).
.TP
File|Open  or 'o':
When you select this function you get a window, at the left side of
the window you get the files of the current directory. By selecting 
a file it will be loaded.
.br
At the right size of the window you see the directories, by pressing
the TAB key you are able to switch between the file and the directory
selection. By selecting a directory with ENTER you change the current
directory.
.br
With the ESC key you cancel the file open operation.
.TP
File|Quit   or 'F10,ESC,q':
Quit program.
.TP
Go|to begin   or 'b':
Move to the first line of the file.
.TP	  
Go|to end   or 'e':
Move to the last line of the file.
.TP	  
Go|to line  or 'g':
With this function you are able to move to a certain line number.
After you have selected this function you get a window which ask 
you to give a line number. With ESC you cancel the operation, by 
pressing the TAB key you can use the [   OK   ] and [ Cancel ] 
buttons.
.TP	  
Go|to end of a line   or 'END':
Move to the end of a line.
.TP	  
Go|to begin of a line   or 'HOME':
Move to the begin of a line.
.TP	  
Search|a string   or '/,z,s,f'
With this function you can search for a string in the file. The 
searching will start form the current line (the first line on the 
screen) to the last line in the file. After you selected this 
function you will see a window which ask you to give a string. The 
searching can been done on two ways, with or without case 
sensitivity. By pressing the TAB key you can select -with SPACE or 
ENTER- how to search at
	     
   [ ] Case sensitive
	     
With the TAB key you are also able to use the [   OK   ] and [ Cancel ] buttons.
.TP	  
Search|form begin of the file
See above, the searching will start form the first line.
.TP	  
Search|Again  or 'F3'
Search for the last string again.
.TP       
Option|cursor
Turn the cursor on/off
.TP       
Option|give notice
Notice on exit on/off
.TP       
Option|types
Add, delete, modify types
.TP	  
Optine|Save options
Save the options to your cfg file ($HOME/.lookat)
.TP	  
Help|See help file  or 'F1,h,?'
View this help file.
.TP       
Help|Keys ...
Shows a list with the keys you can use in "see".
.TP	  
Help|About
Shows information about the program (version ,etc.).
.TP
Configuration
lookat uses two configuration files a global configuration file
( /etc/lookat.conf ) and a user configuration file ( $HOME/.lookat )
if the user's configuration file exists the global is ignored.
.br

If the configuration files aren't available the defaults are used.
.br

There are three entries in the configuration file:
   
  cursor      = on / off  turn the cursor on / off
.br
  give_notice = on / off  notice on exit  on / off
.br
  .name        = "external cmd"  create a new type 
.br

If a filename match a type the external command will be used to open
the file. A typical usage are gzipped files:
.br

     .gz	 = "gzip -cd"
.br

The type order is important lookat will compare the filename with the types
starting with the first type and continues until a type match a filename.
So if you want to define a type for ".gz" and ".tar.gz" files you have to
put the .tar.gz type first.

.SH BUGS
Not knowed yet, when you find one you may let me know :-)

.SH AUTHOR
V1.2.1 Staf Wagemakers
.br
email: staf@digibel.org
.br
homepage: http://www.digibel.org/~staf
